function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import * as hooks from "../hooks";
import * as effects from "../effects";

function Component(props) {
  this.props = props;
}

Component.prototype[hooks.RenderSymbol] = function (newProps, Class) {
  var _hooks$createSlot = hooks.createSlot(),
      _hooks$createSlot2 = _slicedToArray(_hooks$createSlot, 2),
      slots = _hooks$createSlot2[0],
      index = _hooks$createSlot2[1];

  var slot = slots[index];
  var instance;
  var stateChanges;
  var shouldUpdate;
  var prevProps;
  var prevState;
  var newState;
  var i;

  if (!slot) {
    stateChanges = [];
    instance = new Class(newProps);
    instance.props = newProps;
    slot = slots[index] = {
      i: instance,
      s: stateChanges,
      u: hooks.createScheduleRender(),
      f: false,
      // forceRender flag
      r: undefined // rendering instructions

    };

    instance.setState = newState => {
      stateChanges.push(typeof newState === "function" ? newState : () => newState);
      slot.u();
    };

    instance.forceUpdate = () => {
      slot.f = true;
      slot.u();
    };

    effects.addEffect(() => {
      instance.componentDidMount();
    });
    hooks.addCleanup(() => {
      instance.componentWillUnmount();
    });
    return slot.r = instance.render();
  } else {
    instance = slot.i;
    slot.u = hooks.createScheduleRender();
    prevProps = instance.props;
    prevState = instance.state;
    stateChanges = slot.s;
    newState = prevState;

    for (i = 0; i < stateChanges.length; i++) {
      newState = Object.assign({}, newState, stateChanges[i](newState));
    }

    stateChanges.length = 0;
    shouldUpdate = slot.f || instance.shouldComponentUpdate(newProps, newState);
    instance.props = newProps;
    instance.state = newState;
    slot.f = false;

    if (shouldUpdate) {
      effects.addEffect(() => {
        instance.componentDidUpdate(prevProps, prevState);
      });
      slot.r = instance.render();
    }

    return slot.r;
  }
};

Component.prototype.shouldComponentUpdate = () => true;

Component.prototype.componentDidUpdate = () => {};

Component.prototype.componentWillUnmount = () => {};

Component.prototype.componentDidMount = () => {};

export { Component as default };